运维开发网

在Linux中为旧内核编译程序

运维开发网 https://www.qedev.com 2020-05-19 14:55 出处:网络
我在最新的 Linux机器上静态编译和链接程序,并在另一个9岁的Linux中运行它.它给了我一个错误“致命:内核太旧”并退出.具体来说,新的是Fedora 18(gcc 4.7.2,glibc 2.16,内核3.7.2),旧的是RHEL4.8(glibc 2.3.4,内核
我在最新的 Linux机器上静态编译和链接程序,并在另一个9岁的Linux中运行它.它给了我一个错误“致命:内核太旧”并退出.具体来说,新的是Fedora 18(gcc 4.7.2,glibc 2.16,内核3.7.2),旧的是RHEL4.8(glibc 2.3.4,内核2.6.9).由于它是静态链接,因此glibc版本无关紧要.我想这里的问题是该程序调用的系统调用不在旧内核中.

如果旧系统上的开发不是一个选项,我如何在新系统中构建程序并在较旧的系统中运行(甚至更好)?我一直在寻找一种在兼容模式下运行gcc的方法,它只调用旧的系统调用.没有运气了.

最简单的选择是始终在旧系统上构建.

或者,将glibc头文件和静态库从旧系统复制到新系统并链接到那些.

如果这不起作用,你将不得不用–enable-kernel = 2.6.9或类似的东西来重建glibc.

0

精彩评论

暂无评论...
验证码 换一张
取 消